/**
 * Created by leonardooliveira on 07/03/2016.
 */
var TipoAjusteReceberController = function(General, ScreenService, templateManager, TipoAjusteReceberService){

    var enableAll = [
        "CDAJUCTREC", "DSAJUCTREC", "IDAJUCTREC", "CDCONTCTBL", "DSHISTPADR", "IDTPAJRECEBER", "IDCTBAJCTREC"
    ];

    /*this.editarTipoDeAjuste = function(args){
        args.owner.widget.edit();
        args.owner.widget.getField('IDNOVO').value('N');
        enableDisable(args.owner.widget, enableAll, false);

        enableDisable(args.owner.widget, ["CDAJUCTREC", "IDAJUCTREC", "IDTPAJRECEBER", "IDCTBAJCTREC"], true);

    };*/

    this.novoTipoDeAjuste = function(args){
        //args.owner.widget.currentRow = {};
        widget = args.owner.widget;
        //widget.template = "widget/form.html";
        widget.edit();
        widget.newRow();
        widget.getField('NRORG').value(getLocalVar('NRORGTRAB'));
        widget.getField('IDAJUCTREC').value('A');
        widget.getField('IDTPAJRECEBER').value('N');
        widget.getField('IDCTBAJCTREC').value('S');
        widget.getField('IDNOVO').value('S');
        //widget.edit();
        //ScreenService.openSwipe(args.owner.widget);
        enableDisable(args.owner.widget, enableAll, false);
    };

    this.salvarTipoAjuste = function(args){
        /*var tipoAjusteReceberGrid = args.owner.widget;
        if(!tipoAjusteReceberGrid.isValid()){
            ScreenService.alertNotification('Preencha todos os campos obrigatórios.', 5000);
        }else {
            TipoAjusteReceberService.salvarTipoAjuste(tipoAjusteReceberGrid.currentRow).then(function () {
                ScreenService.successNotification('Registro salvo com sucesso', 5000);
                tipoAjusteReceberGrid.reload();
                tipoAjusteReceberGrid.view();
                ScreenService.goBack();
            }, function (error) {
                ScreenService.notificationMessage(error.data['error'], 'error', 5000);
            });
        }*/
        
        widget = args.owner.widget;
        if(widget.isValid()){
            General.saveCrud(widget).then(
                function success(success) {
                    /*widget.reload().then(function(){
                        if(widget.isNewRow()){
                            widget.reload().then(function(){
                                ScreenService.goBack();
                                //ScreenService.showMessage(ScreenService.i18n('Salvo com sucesso.'));
                            });
                        }
                    });*/
                    //ScreenService.showMessage(ScreenService.i18n('Salvo com sucesso.'));
                }, function error(error){
                    console.log(error.data.error.indexOf('ORA-01400'));
                    if (error.data && error.data.error.indexOf('ORA-00001') == -1) {
                        ScreenService.showMessage(ScreenService.i18n("Informação já cadastrada."));
                    } else if (error.data && error.data.error.indexOf('ORA-01400') !== -1){
                        ScreenService.showMessage(ScreenService.i18n("Existem campos em branco que precisam ser preenchidos."));
                    }else if (error.data.error) {
                        ScreenService.showMessage(ScreenService.i18n(error.data.error));
                    } else {
                        ScreenService.showMessage(ScreenService.i18n("Verifique sua conexão e tente novamente"));
                    }
                }
            );
        }
        //ScreenService.goBack();
    };

    this.deletarTipoAjuste = function(tipoAjusteReceberGrid){
        //ScreenService.confirmMessage('Deseja excluir o tipo de ajuste?').then(function(){
            General.deleteCrud(tipoAjusteReceberGrid).then(function(){
                //ScreenService.successNotification('Registro excluído com sucesso', 5000);
                tipoAjusteReceberGrid.reload();
                tipoAjusteReceberGrid.view();
                ScreenService.goBack();
            }, function(error){
                ScreenService.notificationMessage(error.data.error, 'error', 5000);
            });
            /*TipoAjusteReceberService.deletarTipoAjuste(tipoAjusteReceberGrid.currentRow).then(function(){
                ScreenService.successNotification('Registro excluído com sucesso', 5000);
                tipoAjusteReceberGrid.reload();
                tipoAjusteReceberGrid.view();
                ScreenService.goBack();
            }, function(error){
                ScreenService.notificationMessage(error.data['error'], 'error', 5000);
            });*/
        //});        
    };

    var enableDisable = function(widget, fields, enableDisable){
        var i = 0;
        if(enableDisable) {
            for (i = 0; i < fields.length; i++) {
                widget.getField(fields[i]).readOnly = true;
            }
        }else{
            for (i = 0; i < fields.length; i++) {
                widget.getField(fields[i]).readOnly = false;
            }
        }
    };
    
    var self = this;
    
    this.configContctblField = function() {
      
      self.setContctblMask();
      self.setContctblFilter();
      
    };
    
    this.setContctblMask = function() {
        
        TipoAjusteReceberService.getContctblMask().then(function(response){
            
            var paramgeral = response.dataset.paramgeral[0];
            var contctblMask = paramgeral.CDPICTCCTB;
            
            //fields[0] = CDCONTCTBL
            templateManager.container.getWidget('tipoAjusteReceberGrid').getField('CDCONTCTBL').fields[0].mask.params.mask = contctblMask;
            templateManager.container.getWidget('tipoAjusteReceberGrid').getField('CDCONTCTBL').mask.params.mask = contctblMask;
            
        });
        
    };
    
    this.setContctblFilter = function() {
      
      TipoAjusteReceberService.getNvMaxContctbl().then(function(response) {
        var NVMAXCONTCTBL = response.dataset.paramgeral.NVMAXCONTCTBL;
        
        //dataSourceFilter[0]: {name: "CDNVCONTCTBL", operator: "="}
        templateManager.container.getWidget('tipoAjusteReceberGrid').getField('CDCONTCTBL').dataSourceFilter[0].value = NVMAXCONTCTBL;
        
      });
      
      
    };
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('TipoAjusteReceberController', TipoAjusteReceberController);
});